#ifndef ERRORS_HPP
#define ERRORS_HPP

/*
 * Exceptions for errors gestion.
 */

#include <exception>

/* Namespace for errors gestion. */
namespace Errors {
/* -- Graphical interface errors. ---------------------------------------- */
  class InterfaceError: public std::exception {
    public:
      /* Default constructor. */
      InterfaceError () throw () {}

      /* Destructor. */
      virtual ~InterfaceError () throw () {}

      /* Generates error mmessage. */
      virtual const char* what () const throw () {
        return "graphical interface error";
      }
  };

/* -- Erreur lors de la configuration d’OpenGL. -------------------------- */
  class GLConfigurationError: public InterfaceError {
    public:
      /* Default constructor. */
      GLConfigurationError () throw () {}

      /* Destructor. */
      virtual ~GLConfigurationError () throw () {}

      /* Generates error mmessage. */
      virtual const char* what () const throw () {
        return "OpenGL configuration error";
      }
  };

/* -- Erreur lors de la création du contexte OpenGL. --------------------- */
  class ContextCreationError: public InterfaceError {
    public:
      /* Default constructor. */
      ContextCreationError () throw () {}

      /* Destructor. */
      virtual ~ContextCreationError () throw () {}

      /* Generates error mmessage. */
      virtual const char* what () const throw () {
        return "OpenGL context creation error";
      }
  };

/* -- Erreur à l’obtention du contexte OpenGL. --------------------------- */
  class GettingContextError: public InterfaceError {
    public:
      /* Default constructor. */
      GettingContextError () throw () {}

      /* Destructor. */
      virtual ~GettingContextError () throw () {}

      /* Generates error mmessage. */
      virtual const char* what () const throw () {
        return "impossible to get OpenGL context";
      }
  };
}

#endif  // #ifndef ERRORS_HPP
